WKSChart Class Reference documentation

Classes | Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | Private Member Functions | Friends | List of all members
WKSChart Class Referenceabstract

a class used to store a chart associated to a spreadsheet .... More...

`#include <WKSChart.h>`

Inheritance diagram for WKSChart:

## Classes
struct | Axis
| a axis in a chart More...
struct | Legend
| a legend in a chart More...
struct | Position
| a cell position More...
struct | Serie
| a serie in a chart More...
struct | TextZone
| a text zone a chart More...

## Public Member Functions
| WKSChart (Vec2f const &dim=Vec2f())
| the constructor
virtual | ~WKSChart ()
| the destructor
void | sendChart (WKSContentListenerPtr &listener, librevenge::RVNGSpreadsheetInterface *interface) const
| send the chart to the listener
virtual void | sendContent (TextZone const &zone, WPSListenerPtr &listener) const =0
| send the zone content (called when the zone is of text type)
void | setGridColor (WPSColor const &color)
| set the grid color
Axis & | getAxis (int coord)
| return an axis (corresponding to a coord)
Axis const & | getAxis (int coord) const
| return an axis (corresponding to a coord)
Legend const & | getLegend () const
| returns the legend
Legend & | getLegend ()
| returns the legend
Serie * | getSerie (int id, bool create)
| return a serie
std::map< int, Serie > const & | getIdSerieMap () const
| returns the list of defined series
TextZone * | getTextZone (TextZone::Type type, bool create=false)
| returns a textzone content

## Public Attributes
Vec2f | m_dimension
| the chart dimension in point
Serie::Type | m_type
| the chart type (if no series)
bool | m_dataStacked
| a flag to know if the data are stacked or not
bool | m_dataPercentStacked
| a flag to know if the data are percent stacked or not
bool | m_dataVertical
| a flag to know if the data are vertical (for bar)
bool | m_is3D
| a flag to know if the graphic is 3D
bool | m_is3DDeep
| a flag to know if real 3D or 2D-extended
WPSGraphicStyle | m_style
| the chart style
librevenge::RVNGString | m_name
| the chart name
WPSBox2f | m_plotAreaPosition
| the plot area dimension in percent
WPSGraphicStyle | m_plotAreaStyle
| the ploat area style
WPSBox2f | m_legendPosition
| the legend dimension in percent
WPSGraphicStyle | m_floorStyle
| floor
WPSGraphicStyle | m_wallStyle
| wall

## Protected Member Functions
void | sendTextZoneContent (TextZone::Type type, WPSListenerPtr listener) const
| sends a textzone content

## Protected Attributes
WPSColor | m_gridColor
| the grid color
Axis | m_axis [5]
| the x,y,y-second,z and a bad axis
Legend | m_legend
| the legend
std::map< int, Serie > | m_serieMap
| the list of series
std::map< TextZone::Type, TextZone > | m_textZoneMap
| a map text zone type to text zone

## Private Member Functions
| WKSChart (WKSChart const &orig)=delete
WKSChart & | operator= (WKSChart const &orig)=delete

## Friends
class | WKSChartInternal::SubDocument

## Detailed Description

a class used to store a chart associated to a spreadsheet ....

## Constructor & Destructor Documentation

## ◆ WKSChart() [1/2]

WKSChart::WKSChart | ( | Vec2f const & | dim = `Vec2f()` | ) |
| explicit

the constructor

## ◆ ~WKSChart()

WKSChart::~WKSChart | ( |  | ) |
| virtual

the destructor

## ◆ WKSChart() [2/2]

WKSChart::WKSChart | ( | WKSChart const & | orig | ) |
| explicitprivatedelete

## Member Function Documentation

## ◆ getAxis() [1/2]

WKSChart::Axis & WKSChart::getAxis | ( | int | coord | ) |

return an axis (corresponding to a coord)

Referenced by LotusChart::updateChart(), WKS4Chart::updateChart(), and QuattroDosChart::updateSpreadsheetNames().

## ◆ getAxis() [2/2]

WKSChart::Axis const & WKSChart::getAxis | ( | int | coord | ) | const

return an axis (corresponding to a coord)

## ◆ getIdSerieMap()

std::map< int, Serie > const & WKSChart::getIdSerieMap | ( |  | ) | const
| inline

returns the list of defined series

Referenced by LotusChart::updateChart(), and QuattroDosChart::updateSpreadsheetNames().

## ◆ getLegend() [1/2]

Legend & WKSChart::getLegend | ( |  | ) |
| inline

returns the legend

## ◆ getLegend() [2/2]

Legend const & WKSChart::getLegend | ( |  | ) | const
| inline

returns the legend

Referenced by LotusChart::updateChart().

## ◆ getSerie()

WKSChart::Serie * WKSChart::getSerie | ( | int | id,
|  | bool | create
| ) |  |

return a serie

Referenced by WKS4ChartInternal::Chart::empty(), LotusChart::updateChart(), and WKS4Chart::updateChart().

## ◆ getTextZone()

WKSChart::TextZone * WKSChart::getTextZone | ( | TextZone::Type | type,
|  | bool | create = `false`
| ) |  |

returns a textzone content

Referenced by LotusChart::updateChart().

## ◆ operator=()

WKSChart & WKSChart::operator= | ( | WKSChart const & | orig | ) |
| privatedelete

## ◆ sendChart()

void WKSChart::sendChart | ( | WKSContentListenerPtr & | listener,
|  | librevenge::RVNGSpreadsheetInterface * | interface
| ) |  | const

send the chart to the listener

Referenced by WKSContentListener::insertChart().

## ◆ sendContent()

virtual void WKSChart::sendContent | ( | TextZone const & | zone,
|  | WPSListenerPtr & | listener
| ) |  | const
| pure virtual

send the zone content (called when the zone is of text type)

Implemented in LotusChartInternal::Chart, QuattroDosChartInternal::Chart, and WKS4ChartInternal::Chart.

Referenced by sendTextZoneContent().

## ◆ sendTextZoneContent()

void WKSChart::sendTextZoneContent | ( | TextZone::Type | type,
|  | WPSListenerPtr | listener
| ) |  | const
| protected

sends a textzone content

Referenced by WKSChartInternal::SubDocument::parse().

## ◆ setGridColor()

void WKSChart::setGridColor | ( | WPSColor const & | color | ) |
| inline

set the grid color

## Friends And Related Function Documentation

## ◆ WKSChartInternal::SubDocument

friend class WKSChartInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_axis

Axis WKSChart::m_axis[5]
| protected

the x,y,y-second,z and a bad axis

Referenced by getAxis(), and sendChart().

## ◆ m_dataPercentStacked

bool WKSChart::m_dataPercentStacked

a flag to know if the data are percent stacked or not

Referenced by sendChart().

## ◆ m_dataStacked

bool WKSChart::m_dataStacked

a flag to know if the data are stacked or not

Referenced by sendChart(), and WKS4Chart::updateChart().

## ◆ m_dataVertical

bool WKSChart::m_dataVertical

a flag to know if the data are vertical (for bar)

Referenced by sendChart(), and WKS4Chart::updateChart().

## ◆ m_dimension

Vec2f WKSChart::m_dimension

the chart dimension in point

Referenced by sendChart().

## ◆ m_floorStyle

WPSGraphicStyle WKSChart::m_floorStyle

floor

Referenced by sendChart(), and WKSChart().

## ◆ m_gridColor

WPSColor WKSChart::m_gridColor
| protected

the grid color

Referenced by setGridColor().

## ◆ m_is3D

bool WKSChart::m_is3D

a flag to know if the graphic is 3D

Referenced by sendChart().

## ◆ m_is3DDeep

bool WKSChart::m_is3DDeep

a flag to know if real 3D or 2D-extended

Referenced by sendChart().

## ◆ m_legend

Legend WKSChart::m_legend
| protected

the legend

Referenced by getLegend(), and sendChart().

## ◆ m_legendPosition

WPSBox2f WKSChart::m_legendPosition

the legend dimension in percent

Referenced by sendChart().

## ◆ m_name

librevenge::RVNGString WKSChart::m_name

the chart name

Referenced by WKSContentListener::insertChart().

## ◆ m_plotAreaPosition

WPSBox2f WKSChart::m_plotAreaPosition

the plot area dimension in percent

Referenced by sendChart().

## ◆ m_plotAreaStyle

WPSGraphicStyle WKSChart::m_plotAreaStyle

the ploat area style

Referenced by sendChart().

## ◆ m_serieMap

std::map<int, Serie> WKSChart::m_serieMap
| protected

the list of series

Referenced by getIdSerieMap(), getSerie(), and sendChart().

## ◆ m_style

WPSGraphicStyle WKSChart::m_style

the chart style

Referenced by WKSChart::Axis::addStyleTo(), WKSChart::Legend::addStyleTo(), WKSChart::Serie::addStyleTo(), WKSChart::TextZone::addStyleTo(), sendChart(), and WKSChart::Serie::setPrimaryPattern().

## ◆ m_textZoneMap

std::map<TextZone::Type, TextZone> WKSChart::m_textZoneMap
| protected

a map text zone type to text zone

Referenced by getTextZone(), sendChart(), and sendTextZoneContent().

## ◆ m_type

Serie::Type WKSChart::m_type

the chart type (if no series)

Referenced by WKSChart::Axis::addContentTo(), WKSChart::Serie::addContentTo(), WKSChart::TextZone::addContentTo(), WKSChart::Axis::addStyleTo(), sendChart(), LotusChart::updateChart(), and WKS4Chart::updateChart().

## ◆ m_wallStyle

WPSGraphicStyle WKSChart::m_wallStyle

wall

Referenced by sendChart(), and WKSChart().

The documentation for this class was generated from the following files:

- WKSChart.h
- WKSChart.cpp